package com.nisum.ascend.inventory.service;

import com.nisum.ascend.inventory.dto.ProductDto;
import com.nisum.ascend.inventory.model.Product;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import com.nisum.ascend.inventory.repository.ProductRepository;
import reactor.core.publisher.Mono;

import static com.nisum.ascend.inventory.dto.ProductDto.generateDtoFromProduct;

@Service
public class ProductService {
    @Autowired
    ProductRepository productRepository;

    public Mono<ProductDto> removeProductBySku(String sku){
        return productRepository
                .findBySku(sku)
                .map(ProductDto::generateDtoFromProduct)
                .flatMap(existingProduct -> productRepository.deleteProduct(existingProduct)
                        .then(Mono.just(existingProduct))); //Insert Exception Handling after AFP-56 merge
    }

}
